c/*$The phase of the moon, for your safety and convenience.
c**
c**  Stolen from ArchMach & converted from PL/I by Brian Hess.
c**  Extensively cleaned up by Rich $alz.
c**
c**  If you can figure out how this program works, then YOU deserve
c**  to be working on it, sucker!  Here's a hint:  The epoch is 13:23,
c**  10/1/78.
c*/
c
c vnews 1.4/jms/910805

	Subroutine Phoon(Phrase)

	Implicit None

	include 'phoon.def'

	Integer Phase, Calculate, sys$fao
	Character*(*) Phrase

	Phase = Calculate()

	If (Day .eq. 0 .AND. Hour .eq. 0 .AND. Minute .eq. 0) Then
	    Phrase = 'Exactly the '//Moon(Phase)(:Len(Moon(Phase)))
	Else
	    Call SYS$FAO(
	1     '!UL day!%S, !UL hour!%S, !UL minute!%S since the !AS',,
	2     Phrase,
	3     %VAL(day), %val(hour), %val(minute),
	4     moon(phase)(:len(moon(phase))) )

	EndIf

	Return

	End


	integer function calculate()

	Implicit None

	include 'phoon.def'

	record /tm_struct/ tm
	integer length, phase, deltah, delta, offset, tick, julian
	integer year, status

	external c$time,localtime
	integer c$time,localtime

	tick = c$time(%VAL(0))
	status = localtime(tick)
	call bcopy( %VAL(status), tm, %VAL(36))

	julian	= tm.tm_yday + 1
	year	= tm.tm_year - 78
	hour	= tm.tm_hour
	minute	= tm.tm_min

	Length	= 2551. / 60. * 1000. + 443. / 60.
	offset	= ((year * 365 + julian) * 24 + hour) * 60 + minute
	Delta	= offset - (273 * 24 + 13) * 60 + 23
	Phase	= Delta - (Delta / Length) * Length

	Fraction = Phase / Length

	Length	= Length / 4
	Phase	= (Phase / Length) + 1
	Delta	= Delta - (Delta / Length) * Length
	DeltaH	= Delta / 60
	Minute	= Delta - DeltaH * 60
	Day	= DeltaH / 24
	Hour	= DeltaH - Day * 24

	Calculate = Phase	
	Return
	End
